/*
 *  Copyright 2012 Anyware Services
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

function onYouTubeIframeAPIReady ()
{
	for (var i=0; i < ytPlayer_array.length; i++)
	{
		var playerId = ytPlayer_array[i][0];
		var playlistId = ytPlayer_array[i][1];
		
		eval('ytPlayer_' + playerId + '= new YT.Player("' + playerId + '", {height: ' + ytPlayer_array[i][2] + ', width: ' + ytPlayer_array[i][3] + ', events: {onReady: function ()  {onPlayerReady ("' + playerId + '", "' + playlistId + '")}}});');
	}
}

var ytPlayer_array = ytPlayer_array || [];

function onPlayerReady (playerId, playlistId)
{
	eval('ytPlayer_' + playerId).loadPlaylist({
		list: playlistId,
        listType: 'playlist',
        index: 0,
        startSeconds: 0
   });
}

function displayPlayList (uniqueId, playlistId)
{
	var divPlayer = $j('#player_' + uniqueId);
	var w = divPlayer.parent().width();
	var oW = divPlayer.outerWidth(true);
	
	var list = $j('#playlist_' + uniqueId);
	var listW = w - oW; 
	if (listW < 200)
	{
		list.width(w);
	}
	else
	{
		list.width(listW);
	}
	list.show();
	
	addVideos (uniqueId, playlistId, 1);
}

function addVideos (uniqueId, playlistId, startIndex)
{
	var playlistURL = 'http://gdata.youtube.com/feeds/api/playlists/' + playlistId + '?v=2&alt=json&start-index=' + startIndex + '&max-results=50&callback=?';
	
	$j.getJSON(playlistURL, function(data)
	{
		var datas = false;
		if (data.feed.entry != null)
		{
			$j.each(data.feed.entry, function(i, item)
			{
				datas = true;
				var title = item.title.$t.replace("\'","&#039;").replace("\"","&#034;");
				var duration = item.media$group.yt$duration.seconds;
				var secondes = duration % 60;
				if (secondes < 10)
				{
					secondes = '0' + secondes;
				}
				var minutes = ((duration-secondes)/60) % 60;
				if (minutes < 10)
				{
					minutes = '0' + minutes;
				}
				var heures = (duration-minutes * 60 - secondes) / 3600;
				var temps = minutes + "m" + secondes;
				if (heures > 0)
				{
					temps = heures + "h" + temps;
				}
				var videoID = item.media$group.yt$videoid.$t;
				var thumb = "http://img.youtube.com/vi/"+ videoID +"/default.jpg";
				var position = item.yt$position.$t - 1;
				$j('#playlist_' + uniqueId).append("<li><a title='" + title + "' href='javascript:playVideo(\"player_" + uniqueId + "\"," + position + ")'><img alt='" + title + "' src='" + thumb + "'/><span class='title'>" + title + "</span><span class='time'>" + temps + "</span></a></li>");
			});
		}
		
		if (datas)
		{
			addVideos (uniqueId, playlistId, startIndex + 50);
		}
	});
}

// This function is called instead of onYouTubeIframeAPIReady, if HTML5 postMessage function is not supported
function createSWFObjectPlayer (uniqueId, playlistID, playerWidth, playerHeight, theme, color)
{
	var playlistURL = 'http://gdata.youtube.com/feeds/api/playlists/' + playlistID + '?v=2&alt=json&start-index=1&max-results=1&callback=?';
	$j.getJSON(playlistURL, function(data)
	{
		var videoID = "";
		if (data.feed.entry != null && data.feed.entry.length > 0)
		{
			var item = data.feed.entry[0];
			
			videoID = item.media$group.yt$videoid.$t;
		}

		var params = { allowScriptAccess: "always" };
		var atts = { id: "ytPlayer_player_" + uniqueId};
		// All of the magic handled by SWFObject (http://code.google.com/p/swfobject/)
		swfobject.embedSWF("https://www.youtube.com/v/videoseries?enablejsapi=1&listType=playlist&version=3&autoplay=1&autohide=1&theme=" + theme + "&color=" + color + "&list=" + playlistID + "&video_id=" + videoID,
		                   "player_" + uniqueId, playerWidth, playerHeight, "9", null, null, params, atts);
	});
}

function playVideo (playerId, videoIndex)
{
	eval('var player = ytPlayer_' + playerId);
	player.playVideoAt(videoIndex);
}
